Index: LMDZ5/branches/testing/libf/phylmd/rrtm/readaerosol_optic_rrtm.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/rrtm/readaerosol_optic_rrtm.F90	(revision 2787)
+++ LMDZ5/branches/testing/libf/phylmd/rrtm/readaerosol_optic_rrtm.F90	(revision 2839)
@@ -17,5 +17,5 @@
   USE phys_local_var_mod, only: sconcso4,sconcno3,sconcoa,sconcbc,sconcss,sconcdust, &
        concso4,concno3,concoa,concbc,concss,concdust,loadso4,loadoa,loadbc,loadss,loaddust, &
-       load_tmp1,load_tmp2,load_tmp3,load_tmp4,load_tmp5,load_tmp6,load_tmp7
+       loadno3, load_tmp1,load_tmp2,load_tmp3
 
   USE infotrac_phy
@@ -195,7 +195,7 @@
      IF ( flag_aerosol .EQ. 3 .OR. flag_aerosol .EQ. 6 ) THEN
 
-        CALL readaerosol_interp(id_ASPOMM_phy, itap, pdtphys, rjourvrai, debut, pplay, paprs, t_seri, pomsol, pomsol_pi, load_tmp3)
-        CALL readaerosol_interp(id_AIPOMM_phy, itap, pdtphys, rjourvrai, debut, pplay, paprs, t_seri, pomins, pomins_pi, load_tmp4)
-        loadoa(:)=load_tmp3(:)+load_tmp4(:)
+        CALL readaerosol_interp(id_ASPOMM_phy, itap, pdtphys, rjourvrai, debut, pplay, paprs, t_seri, pomsol, pomsol_pi, load_tmp1)
+        CALL readaerosol_interp(id_AIPOMM_phy, itap, pdtphys, rjourvrai, debut, pplay, paprs, t_seri, pomins, pomins_pi, load_tmp2)
+        loadoa(:)=load_tmp1(:)+load_tmp2(:)
      ELSE
         pomsol(:,:) = 0. ; pomsol_pi(:,:) = 0.
@@ -208,10 +208,10 @@
 
         CALL readaerosol_interp(id_SSSSM_phy ,itap, pdtphys,rjourvrai, &
-        debut, pplay, paprs, t_seri, sssupco, sssupco_pi, load_tmp5) 
+        debut, pplay, paprs, t_seri, sssupco, sssupco_pi, load_tmp1) 
         CALL readaerosol_interp(id_CSSSM_phy ,itap, pdtphys,rjourvrai, &
-        debut, pplay, paprs, t_seri, sscoarse,sscoarse_pi, load_tmp6) 
-        CALL readaerosol_interp(id_ASSSM_phy ,itap, pdtphys, rjourvrai, &
-        debut, pplay, paprs, t_seri, ssacu, ssacu_pi, load_tmp7) 
-        loadss(:)=load_tmp5(:)+load_tmp6(:)+load_tmp7(:)
+        debut, pplay, paprs, t_seri, sscoarse,sscoarse_pi, load_tmp2) 
+        CALL readaerosol_interp(id_ASSSM_phy ,itap, pdtphys,rjourvrai, &
+        debut, pplay, paprs, t_seri, ssacu, ssacu_pi, load_tmp3) 
+        loadss(:)=load_tmp1(:)+load_tmp2(:)+load_tmp3(:)
      ELSE
         sscoarse(:,:) = 0. ; sscoarse_pi(:,:) = 0. 
@@ -231,15 +231,25 @@
      ENDIF
      !
+     ! Read and interpolate cidustm
+     IF (flag_aerosol .EQ. 6) THEN 
+
+        CALL readaerosol_interp(id_ASNO3M_phy, itap, pdtphys, rjourvrai, & 
+        debut, pplay, paprs, t_seri, nitracc, nitracc_pi, load_tmp1) 
+        CALL readaerosol_interp(id_CSNO3M_phy, itap, pdtphys, rjourvrai, & 
+        debut, pplay, paprs, t_seri, nitrcoarse, nitrcoarse_pi, load_tmp2) 
+        CALL readaerosol_interp(id_CINO3M_phy, itap, pdtphys, rjourvrai, & 
+        debut, pplay, paprs, t_seri, nitrinscoarse, nitrinscoarse_pi, load_tmp3) 
+        loadss(:)=load_tmp1(:)+load_tmp2(:)+load_tmp3(:)
+
+     ELSE
+        nitracc(:,:)         =   0.0 ; nitracc_pi(:,:)      =   0.0 
+        nitrcoarse(:,:)      =   0.0 ; nitrcoarse_pi(:,:)   =   0.0
+        nitrinscoarse(:,:)   =   0.0 ; nitrinscoarse_pi(:,:)=   0.0
+        loadno3(:)=0.0
+     ENDIF
+     !
+     ! CSSO4M is set to 0 as not reliable
      sulfcoarse(:,:)      =   0.0 ! CSSO4M (=SO4) + CSMSAM (=MSA) 
      sulfcoarse_pi(:,:)   =   0.0 ! CSSO4M (=SO4) + CSMSAM (=MSA) pre-ind
-     !
-     !--placeholder for offline nitrate   
-     !
-     nitracc(:,:)         =   0.0 
-     nitracc_pi(:,:)      =   0.0 
-     nitrcoarse(:,:)      =   0.0
-     nitrcoarse_pi(:,:)   =   0.0
-     nitrinscoarse(:,:)   =   0.0
-     nitrinscoarse_pi(:,:)=   0.0
 
   ENDIF !--not aerosol_couple
Index: LMDZ5/branches/testing/libf/phylmd/rrtm/suphec.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/rrtm/suphec.F90	(revision 2787)
+++ LMDZ5/branches/testing/libf/phylmd/rrtm/suphec.F90	(revision 2839)
@@ -129,36 +129,46 @@
 
 IF (LHOOK) CALL DR_HOOK('SUPHEC',0,ZHOOK_HANDLE)
-!CALL GSTATS(1811,0) ! MPL 28.11.08
-!RVTMP2=RCPV/RCPD-1.0_JPRB   !use cp,moist
-RVTMP2=0.0_JPRB              !neglect cp,moist
-RHOH2O=RATM/100._JPRB
-R2ES=611.21_JPRB*RD/RV
-R3LES=17.502_JPRB
-R3IES=22.587_JPRB
-R4LES=32.19_JPRB
-R4IES=-0.7_JPRB
-R5LES=R3LES*(RTT-R4LES)
-R5IES=R3IES*(RTT-R4IES)
-R5ALVCP=R5LES*RLVTT/RCPD
-R5ALSCP=R5IES*RLSTT/RCPD
-RALVDCP=RLVTT/RCPD
-RALSDCP=RLSTT/RCPD
-RALFDCP=RLMLT/RCPD
-RTWAT=RTT
-RTBER=RTT-5._JPRB
-RTBERCU=RTT-5.0_JPRB
-RTICE=RTT-23._JPRB
-RTICECU=RTT-23._JPRB
-
-RTWAT_RTICE_R=1.0_JPRB/(RTWAT-RTICE)
-RTWAT_RTICECU_R=1.0_JPRB/(RTWAT-RTICECU)
-IF(NPHYINT == 0) THEN
-  ISMAX=NSMAX
-ELSE
-  ISMAX=PHYS_GRID%NSMAX
-ENDIF
-
-RKOOP1=2.583_JPRB
-RKOOP2=0.48116E-2_JPRB
+!
+  IF (OK_BAD_ECMWF_THERMO) THEN
+!
+     ! Modify constants defined in suphel.F90 and set RVTMP2 to 0.
+     ! CALL GSTATS(1811,0) ! MPL 28.11.08
+     ! RVTMP2=RCPV/RCPD-1.0_JPRB   !use cp,moist
+     RVTMP2=0.0_JPRB              !neglect cp,moist
+     RHOH2O=RATM/100._JPRB
+     R2ES=611.21_JPRB*RD/RV
+     R3LES=17.502_JPRB
+     R3IES=22.587_JPRB
+     R4LES=32.19_JPRB
+     R4IES=-0.7_JPRB
+     R5LES=R3LES*(RTT-R4LES)
+     R5IES=R3IES*(RTT-R4IES)
+     R5ALVCP=R5LES*RLVTT/RCPD
+     R5ALSCP=R5IES*RLSTT/RCPD
+     RALVDCP=RLVTT/RCPD
+     RALSDCP=RLSTT/RCPD
+     RALFDCP=RLMLT/RCPD
+     RTWAT=RTT
+     RTBER=RTT-5._JPRB
+     RTBERCU=RTT-5.0_JPRB
+     RTICE=RTT-23._JPRB
+     RTICECU=RTT-23._JPRB
+     
+     RTWAT_RTICE_R=1.0_JPRB/(RTWAT-RTICE)
+     RTWAT_RTICECU_R=1.0_JPRB/(RTWAT-RTICECU)
+     IF(NPHYINT == 0) THEN
+       ISMAX=NSMAX
+     ELSE
+       ISMAX=PHYS_GRID%NSMAX
+     ENDIF
+     
+     RKOOP1=2.583_JPRB
+     RKOOP2=0.48116E-2_JPRB
+     
+  ELSE 
+     ! Keep constants defined in suphel.F90
+     RTICE=RTT-23._JPRB
+!
+  ENDIF  ! (OK_BAD_ECMWF_THERMO)
 
 !     ------------------------------------------------------------------
Index: LMDZ5/branches/testing/libf/phylmd/time_phylmdz_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/time_phylmdz_mod.F90	(revision 2787)
+++ LMDZ5/branches/testing/libf/phylmd/time_phylmdz_mod.F90	(revision 2839)
@@ -1,4 +1,4 @@
 !
-! $Id: $
+! $Id$
 !
 MODULE time_phylmdz_mod
@@ -28,5 +28,5 @@
     INTEGER,SAVE :: itaufin_phy      ! final iteration (in itau_phy steps)
 !$OMP THREADPRIVATE(itaufin_phy)
-    REAL,SAVE    :: current_time ! current elapsed time (fraction of day) from the begining of the run
+    REAL,SAVE    :: current_time ! current elapsed time in seconds from the begining of the run
 !$OMP THREADPRIVATE(current_time)
     
@@ -84,7 +84,9 @@
   IMPLICIT NONE
   INCLUDE 'YOMCST.h'
-    REAL,INTENT(IN) :: pdtphys_
-    REAL            :: julian_date
-    
+  REAL,INTENT(IN) :: pdtphys_
+  REAL            :: julian_date
+  INTEGER         :: cur_day
+  REAL            :: cur_sec
+
     ! Check if the physics timestep has changed
     IF ( ABS( (pdtphys-pdtphys_) / ((pdtphys+pdtphys_)/2))> 10.*EPSILON(pdtphys_)) THEN
@@ -95,8 +97,12 @@
     
     ! Update elapsed time since begining of run:
-    current_time=current_time+pdtphys/rday
+    current_time = current_time + pdtphys
+    cur_day = int(current_time/rday)
+    cur_sec = current_time - (cur_day * rday) 
 
     ! Compute corresponding Julian date and update calendar
-    CALL ymds2ju(annee_ref,1,day_ini,(start_time+current_time)*rday,julian_date)
+    cur_day = cur_day + day_ini
+    cur_sec = cur_sec + (start_time * rday)
+    CALL ymds2ju(annee_ref,1, cur_day, cur_sec, julian_date)
     CALL phys_cal_update(julian_date)
     
Index: LMDZ5/branches/testing/libf/phylmd/tropopause_m.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/tropopause_m.F90	(revision 2839)
+++ LMDZ5/branches/testing/libf/phylmd/tropopause_m.F90	(revision 2839)
@@ -0,0 +1,104 @@
+MODULE tropopause_m
+
+!  USE phys_local_var_mod, ONLY: ptrop => pr_tropopause
+  PRIVATE
+  PUBLIC :: dyn_tropopause
+
+CONTAINS
+
+!-------------------------------------------------------------------------------
+!
+SUBROUTINE dyn_tropopause(t,ts,paprs,pplay,presnivs,rot,ptrop,tpot0,pvor0,pmin0,pmax0)
+!
+!-------------------------------------------------------------------------------
+  USE assert_m,      ONLY: assert
+  USE assert_eq_m,   ONLY: assert_eq
+  USE comvert_mod,   ONLY: preff
+  USE dimphy,        ONLY: klon, klev
+  USE geometry_mod,  ONLY: latitude_deg, longitude_deg
+  USE interpolation, ONLY: locate
+  IMPLICIT NONE
+!-------------------------------------------------------------------------------
+! Arguments:
+  REAL, INTENT(IN)  ::      t(:,:) !--- Cells-centers temperature
+  REAL, INTENT(IN)  ::     ts(:)   !--- Surface       temperature
+  REAL, INTENT(IN)  ::  paprs(:,:) !--- Cells-edges   pressure
+  REAL, INTENT(IN)  ::  pplay(:,:) !--- Cells-centers pressure
+  REAL, INTENT(IN)  :: presnivs(:) !--- Cells-centers nominal pressure
+  REAL, INTENT(IN)  ::    rot(:,:) !--- Cells-centers relative vorticity
+  REAL, INTENT(OUT) :: ptrop(klon) !--- Tropopause pressure
+  REAL, INTENT(IN), OPTIONAL :: tpot0, pvor0, pmin0, pmax0
+!-------------------------------------------------------------------------------
+! Local variables:
+  include "YOMCST.h"
+  CHARACTER(LEN=80)  :: sub
+  INTEGER :: it, i, nsrf, k, nh, kmin, kmax
+  REAL    :: p1, p2, tpo0, pvo0, pmn0, pmx0, al
+  REAL, DIMENSION(klon,klev)   :: t_edg, t_pot
+  REAL, DIMENSION(klon,klev-1) :: pvort
+!-------------------------------------------------------------------------------
+  sub='dyn_tropopause'
+  CALL assert(SIZE(t ,1)==klon, TRIM(sub)//" t klon")
+  CALL assert(SIZE(t ,2)==klev, TRIM(sub)//" t klev")
+  CALL assert(SIZE(ts,1)==klon, TRIM(sub)//" ts klon")
+  CALL assert(SIZE(presnivs,1)==klev, TRIM(sub)//" presnivs klev")
+  CALL assert(SHAPE(paprs)==[klon,klev+1],TRIM(sub)//" paprs shape")
+  CALL assert(SHAPE(pplay)==[klon,klev  ],TRIM(sub)//" pplay shape")
+  CALL assert(SHAPE(rot)  ==[klon,klev  ],TRIM(sub)//" rot shape")
+
+  !--- DEFAULT THRESHOLDS
+  tpo0=380.;   IF(PRESENT(tpot0)) tpo0=tpot0  !--- In kelvins
+  pvo0=2.0;    IF(PRESENT(pvor0)) pvo0=pvor0  !--- In PVU
+  pmn0= 8000.; IF(PRESENT(pmin0)) pmn0=pmin0  !--- In pascals
+  pmx0=50000.; IF(PRESENT(pmax0)) pmx0=pmax0  !--- In pascals
+  kmin=klev-locate(presnivs(klev:1:-1),pmx0)+1
+  kmax=klev-locate(presnivs(klev:1:-1),pmn0)+1
+
+  !--- POTENTIAL TEMPERATURE AT CELLS CENTERS
+  DO k= 1, klev
+    DO i = 1, klon
+      t_pot(i,k) = t(i,k)*(preff/pplay(i,k))**RKAPPA
+    END DO
+  END DO
+
+  !--- TEMPERATURE AT CELLS INTERFACES (except in top layer)
+  t_edg(:,1) = ts(:)
+  DO k= 2, klev
+    DO i = 1, klon
+      al = LOG(pplay(i,k-1)/paprs(i,k))/LOG(pplay(i,k-1)/pplay(i,k))
+      t_edg(i,k) = t(i,k) + al*(t(i,k-1)-t(i,k))
+    END DO
+  END DO
+
+  !--- ERTEL POTENTIAL VORTICITY AT CELLS CENTERS (except in top layer)
+  DO k= 1, klev-1
+    DO i = 1, klon
+      IF(paprs(i,k)==paprs(i,k+1)) THEN; pvort(i,k)=HUGE(1.); CYCLE; END IF
+      pvort(i,k) = -1.E6 * RG * 2.*ROMEGA*ABS(SIN(latitude_deg(i)*RPI/180.))   &
+                         * ( t_edg(i,k+1)*(preff/paprs(i,k+1) )**RKAPPA        &
+                           - t_edg(i,k  )*(preff/paprs(i,k  ) )**RKAPPA)       &
+                         / ( paprs(i,k+1)  -     paprs(i,k  ) )
+    END DO
+  END DO
+
+  !--- LOCATE TROPOPAUSE
+  ptrop(:)=0.
+  DO i = 1, klon
+    !--- Dynamical tropopause
+    it=kmax; DO WHILE(pvort(i,it)>pvo0.AND.it>=kmin); it=it-1; END DO
+    IF(pvort(i,it+1)/=pvort(i,it).AND.ALL([kmax,kmin-1]/=it) &
+      .AND.ALL([pvort(i,it),pvort(i,it+1)]/=HUGE(1.))) THEN
+      al = (pvort(i,it+1)-pvo0)/(pvort(i,it+1)-pvort(i,it))
+      ptrop(i) = MAX(ptrop(i),pplay(i,it)**al * pplay(i,it+1)**(1.-al))
+    END IF
+    !--- Potential temperature iso-surface
+    it = kmin-1+locate(t_pot(i,kmin:kmax),tpo0)
+    IF(t_pot(i,it+1)/=t_pot(i,it).AND.ALL([kmin-1,kmax]/=it)) THEN
+      al = (t_pot(i,it+1)-tpo0)/(t_pot(i,it+1)-t_pot(i,it))
+      ptrop(i) = MAX(ptrop(i),pplay(i,it)**al * pplay(i,it+1)**(1.-al))
+    END IF
+  END DO
+
+END SUBROUTINE dyn_tropopause
+
+END MODULE tropopause_m
Index: LMDZ5/branches/testing/libf/phylmd/yamada4.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/yamada4.F90	(revision 2787)
+++ LMDZ5/branches/testing/libf/phylmd/yamada4.F90	(revision 2839)
@@ -57,5 +57,5 @@
   !                          -> the model can run with longer time-steps.
   !             2016/11/30 (EV etienne.vignon@univ-grenoble-alpes.fr)
-  !               On met tke (=q2/2) en entrée plutôt que q2
+  !               On met tke (=q2/2) en entr??e plut??t que q2
   !               On corrige l'update de la tke
   !
@@ -120,5 +120,7 @@
   DATA first, ipas/.FALSE., 0/
   !$OMP THREADPRIVATE( first,ipas)
-  LOGICAL hboville
+  LOGICAL,SAVE :: hboville=.TRUE.
+  REAL,SAVE :: viscom,viscoh
+  !$OMP THREADPRIVATE( hboville,viscom,viscoh)
   INTEGER ig, k
   REAL ri, zrif, zalpha, zsm, zsn
@@ -130,4 +132,5 @@
   REAL zz(klon, klev+1)
   INTEGER iter
+  REAL dissip(klon,klev), tkeprov,tkeexp, shear(klon,klev), buoy(klon,klev)
   REAL,SAVE :: ric0,ric,rifc, b1, kap
   !$OMP THREADPRIVATE(ric0,ric,rifc,b1,kap)
@@ -138,6 +141,7 @@
   !$OMP THREADPRIVATE(lmixmin)
   LOGICAL, SAVE :: new_yamada4
-  !$OMP THREADPRIVATE(new_yamada4)
-  REAL, SAVE :: yun,ydeux
+  INTEGER, SAVE :: yamada4_num
+  !$OMP THREADPRIVATE(new_yamada4,yamada4_num)
+  REAL, SAVE :: yun,ydeux,disseff
   !$OMP THREADPRIVATE(yun,ydeux)
   REAL frif, falpha, fsm
@@ -161,7 +165,7 @@
     new_yamada4=.false.
     CALL getin_p('new_yamada4',new_yamada4)
-! Pour garantir la continuite dans la mise au point de CMIP6.
-! Eliminer l'option new_yamada4 des le printemps 2016
+
     IF (new_yamada4) THEN
+! Corrections et reglages issus du travail de these d'Etienne Vignon.
        ric=0.143 ! qui donne des valeurs proches des seuils proposes
                  ! dans YAMADA 1983 : sm=0.0845 (0.085 dans Y83)
@@ -169,5 +173,5 @@
        CALL getin_p('yamada4_ric',ric)
        ric0=0.19489      ! ric=0.195 originalement, mais produisait sm<0
-       ric=min(ric,ric0) ! Au delà de ric0, sm devient négatif
+       ric=min(ric,ric0) ! Au dela de ric0, sm devient n??gatif
        rifc=frif(ric)
        seuilsm=fsm(frif(ric))
@@ -175,8 +179,10 @@
        yun=1.
        ydeux=2.
-!      yun=2.
-!      ydeux=1.
+       hboville=.FALSE.
+       viscom=1.46E-5
+       viscoh=2.06E-5
+       lmixmin=0.
+       yamada4_num=5
     ELSE
-  !!  DATA ric, rifc, b1, kap/0.195, 0.191, 16.6, 0.4/
        ric=0.195
        rifc=0.191
@@ -185,9 +191,16 @@
        yun=2.
        ydeux=1.
+       hboville=.TRUE.
+       viscom=0.
+       viscoh=0.
+       lmixmin=1.
+       yamada4_num=0
     ENDIF
+
     PRINT*,'YAMADA4 RIc, RIfc, Sm_min, Alpha_min',ric,rifc,seuilsm,seuilalpha
     firstcall = .FALSE.
-    lmixmin=1.
     CALL getin_p('lmixmin',lmixmin)
+    CALL getin_p('yamada4_hboville',hboville)
+    CALL getin_p('yamada4_num',yamada4_num)
   END IF
 
@@ -199,5 +212,4 @@
 
 ! On utilise ou non la routine de Holstalg Boville pour les cas tres stables
-   hboville=.TRUE.
 
 
@@ -290,5 +302,5 @@
   !=======================================================================
 
-  ! On commence par calculé q2 à partir de la tke
+  ! On commence par calculer q2 a partir de la tke
 
   IF (new_yamada4) THEN
@@ -400,4 +412,103 @@
   ELSE IF (iflag_pbl>=10) THEN
 
+    IF (yamada4_num>=1) THEN
+ 
+    DO k = 2, klev - 1
+      DO ig=1,ngrid
+      q2(ig, k) = min(max(q2(ig,k),1.E-10), 1.E4)
+      km(ig, k) = l(ig, k)*sqrt(q2(ig,k))*sm(ig, k)
+      shear(ig,k)=km(ig, k)*m2(ig, k)
+      buoy(ig,k)=km(ig, k)*m2(ig, k)*(-1.*rif(ig,k))
+      dissip(ig,k)=((sqrt(q2(ig,k)))**3)/(b1*l(ig,k))
+     ENDDO
+    ENDDO
+
+    IF (yamada4_num==1) THEN ! Schema du MAR tel quel
+       DO k = 2, klev - 1
+         DO ig=1,ngrid
+         tkeprov=q2(ig,k)/ydeux
+         tkeprov= tkeprov*                           &
+           &  (tkeprov+dt*(shear(ig,k)+max(0.,buoy(ig,k))))/ &
+           &  (tkeprov+dt*((-1.)*min(0.,buoy(ig,k))+dissip(ig,k)))
+         q2(ig,k)=tkeprov*ydeux
+        ENDDO
+       ENDDO
+    ELSE IF (yamada4_num==2) THEN ! version modifiee avec integration exacte pour la dissipation
+       DO k = 2, klev - 1
+         DO ig=1,ngrid
+         tkeprov=q2(ig,k)/ydeux
+         disseff=dissip(ig,k)-min(0.,buoy(ig,k))
+         tkeprov = tkeprov/(1.+dt*disseff/(2.*tkeprov))**2
+         tkeprov= tkeprov+dt*(shear(ig,k)+max(0.,buoy(ig,k)))
+         q2(ig,k)=tkeprov*ydeux
+         ! En cas stable, on traite la flotabilite comme la
+         ! dissipation, en supposant que buoy/q2^3 est constant.
+         ! Puis on prend la solution exacte
+        ENDDO
+       ENDDO
+    ELSE IF (yamada4_num==3) THEN ! version modifiee avec integration exacte pour la dissipation
+       DO k = 2, klev - 1
+         DO ig=1,ngrid
+         tkeprov=q2(ig,k)/ydeux
+         disseff=dissip(ig,k)-min(0.,buoy(ig,k))
+         tkeprov=tkeprov*exp(-dt*disseff/tkeprov)
+         tkeprov= tkeprov+dt*(shear(ig,k)+max(0.,buoy(ig,k)))
+         q2(ig,k)=tkeprov*ydeux
+         ! En cas stable, on traite la flotabilite comme la
+         ! dissipation, en supposant que buoy/q2^3 est constant.
+         ! Puis on prend la solution exacte
+        ENDDO
+       ENDDO
+    ELSE IF (yamada4_num==4) THEN ! version modifiee avec integration exacte pour la dissipation
+       DO k = 2, klev - 1
+         DO ig=1,ngrid
+         tkeprov=q2(ig,k)/ydeux
+         tkeprov= tkeprov+dt*(shear(ig,k)+max(0.,buoy(ig,k)))
+         tkeprov= tkeprov*                           &
+           &  tkeprov/ &
+           &  (tkeprov+dt*((-1.)*min(0.,buoy(ig,k))+dissip(ig,k)))
+         q2(ig,k)=tkeprov*ydeux
+         ! En cas stable, on traite la flotabilite comme la
+         ! dissipation, en supposant que buoy/q2^3 est constant.
+         ! Puis on prend la solution exacte
+        ENDDO
+       ENDDO
+    ELSE IF (yamada4_num==5) THEN ! version modifiee avec integration exacte pour la dissipation
+       DO k = 2, klev - 1
+         DO ig=1,ngrid
+         tkeprov=q2(ig,k)/ydeux
+         disseff=dissip(ig,k)-min(0.,buoy(ig,k))
+         tkeexp=exp(-dt*disseff/tkeprov)
+         tkeprov= shear(ig,k)*tkeprov/disseff*(1.-tkeexp)+tkeprov*tkeexp
+         q2(ig,k)=tkeprov*ydeux
+         ! En cas stable, on traite la flotabilite comme la
+         ! dissipation, en supposant que buoy/q2^3 est constant.
+         ! Puis on prend la solution exacte
+        ENDDO
+       ENDDO
+    ELSE IF (yamada4_num==6) THEN ! version modifiee avec integration exacte pour la dissipation
+       DO k = 2, klev - 1
+         DO ig=1,ngrid
+         tkeprov=q2(ig,k)/ydeux
+         tkeprov=tkeprov+max(buoy(ig,k)+shear(ig,k),0.)*dt
+         disseff=dissip(ig,k)-min(0.,buoy(ig,k)+shear(ig,k))
+         tkeexp=exp(-dt*disseff/tkeprov)
+         tkeprov= tkeprov*tkeexp
+         q2(ig,k)=tkeprov*ydeux
+         ! En cas stable, on traite la flotabilite comme la
+         ! dissipation, en supposant que buoy/q2^3 est constant.
+         ! Puis on prend la solution exacte
+        ENDDO
+       ENDDO
+    ENDIF
+
+    DO k = 2, klev - 1
+      DO ig=1,ngrid
+      q2(ig, k) = min(max(q2(ig,k),1.E-10), 1.E4)
+      ENDDO
+    ENDDO
+
+   ELSE 
+
     DO k = 2, klev - 1
       km(1:ngrid, k) = l(1:ngrid, k)*sqrt(q2(1:ngrid,k))*sm(1:ngrid, k)
@@ -410,4 +521,5 @@
     END DO
 
+  ENDIF
 
   ELSE
@@ -529,4 +641,9 @@
  END IF ! hboville
 
+! Ajout d'une viscosite moleculaire
+   km(:,:)=km(:,:)+viscom
+   kn(:,:)=kn(:,:)+viscoh
+   kq(:,:)=kq(:,:)+viscoh
+
   IF (prt_level>1) THEN
     PRINT *, 'YAMADA4 1'
@@ -575,5 +692,5 @@
 
 !============================================================================
-! Mise à jour de la tke
+! Mise a jour de la tke
 !============================================================================
 
